<?php declare(strict_types=1);

namespace Reloadify\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1658835830AddAbandonedCartEntity extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1658835830;
    }

    public function update(Connection $connection): void
    {
        $query = <<< SQL
CREATE TABLE `reloadify_abandoned_cart` (
    `id` BINARY(16) NOT NULL,
    `token` VARCHAR(255) NOT NULL,
    `cart` LONGTEXT NOT NULL,
    `payload` JSON NOT NULL,
    `customer_id` BINARY(16) NULL,
    `created_at` DATETIME(3) NOT NULL,
    `updated_at` DATETIME(3) NULL,
    PRIMARY KEY (`id`),
    CONSTRAINT `json.reloadify_abandoned_cart.payload` CHECK (JSON_VALID(`payload`)),
    KEY `fk.reloadify_abandoned_cart.customer_id` (`customer_id`),
    CONSTRAINT `fk.reloadify_abandoned_cart.customer_id` FOREIGN KEY (`customer_id`) REFERENCES `customer` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
SQL;

        $connection->executeStatement($query);
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
